<?php
defined('_JEXEC') or die('Restricted access');
class plgHikashoppaymentWestpacnet extends hikashopPaymentPlugin
{
	var $accepted_currencies = array( "AUD" ); //change for final version!
	var $multiple = true;
	var $name = 'westpacnet';

	//backend spec config
	var $pluginConfig = array(

		//common params
		'username'=> array('Username','input'),
		'password'=> array('Password','input'),
		'merchant_id' => array("Merchant Id",'input'),
		'ipaddress' => array('Your IP address','html',''),
		'biller_code' => array("billercode",'input'),
		'encryptionkey' => array("Encryption Key",'input'),
		'return_link_url'=> array("URL notification in westpac net settings page",'html',''),

		//General spec
		'testingmode'=> array("testing Mode",'boolean','0'),
		'debug' => array("DEBUG",'boolean','0'),
		'notification'=> array("allow notification from westpac net",'boolean','0'),
		'invalid_status' => array('INVALID_STATUS', 'orderstatus'),
		'verified_status' => array('VERIFIED_STATUS', 'orderstatus'),
	);

	function __construct(&$subject, $config)
	{
		//Set return url, ip address & notify url
		$httpsHikashop = str_replace('http://','https://', HIKASHOP_LIVE);
		$this->pluginConfig['return_link_url'][2] = $httpsHikashop.'index.php?option=com_hikashop&amp;ctrl=checkout&amp;task=notify&amp;notif_payment=westpacnet&amp;tmpl=component?payment_reference&amp;payment_status';
		$this->pluginConfig['ipaddress'][2] = $_SERVER['SERVER_ADDR'];

		return parent::__construct($subject, $config);
	}

	function onAfterOrderConfirm(&$order, &$methods, $method_id)
	{
		parent::onAfterOrderConfirm($order,$methods,$method_id);

		// Net check
		if (empty($this->payment_params->merchant_id))
		{
			$this->app->enqueueMessage('You have to configure a merchant id for the westpac net plugin payment first : check your plugin\'s parameters, on your website backend', 'error');
			return false;
		}

		if (empty($this->payment_params->biller_code))
		{
			$this->app->enqueueMessage('You have to configure a biller code for the westpac net plugin payment first : check your plugin\'s parameters,
			on your website backend','error');

			return false;
		}

		if (empty($this->payment_params->username))
		{
			$this->app->enqueueMessage('You have to configure your username for the westpac net plugin payment first : check your plugin\'s parameters,
			on your website backend','error');

			return false;
		}

		if (empty($this->payment_params->password))
		{
			$this->app->enqueueMessage('You have to configure your password for the westpac net plugin payment first : check your plugin\'s parameters,
			on your website backend','error');

			return false;
		}

		//set data for westpac
		$config =& hikashop_config();

		//Get shopper mail
		$shopper_mail = $config->get('payment_notification_email');

		if(!empty($shopper_mail)) {
			$mail = trim($config->get('payment_notification_email'));
			$mail = explode(',',$mail);
			$shopper_mail = reset($mail);
		}
		else {
			$mail = trim($config->get('from_email'));
			$mail = explode(',',$mail);
			$shopper_mail = reset($mail);
		}

		//Set amount
		$amount = round($order->cart->full_total->prices[0]->price_value_with_tax,2);

		//Set notify Url:
		//$notify_url = 'https://www.hikashop.com/index.php?option=com_hikashop&amp;ctrl=checkout&amp;task=notify&amp;notif_payment=westpacnet&amp;tmpl=component?payment_reference&amp;payment_status';

		//required data for westpacnet platform /NET Mode
		$vars = array(

			//token request
			'biller_code' => trim($this->payment_params->biller_code),
			'merchant_id' => trim($this->payment_params->merchant_id),
			'username' => trim($this->payment_params->username),
			'password' => trim($this->payment_params->password),

			//categories parameters to PayWay
			'information_fields' => '',//Name,Adress,Adress2',
			'required_fields' => '',//'biller_code,username,password',
			'hidden_fields' => '',//'payment_reference,MakePayment,merchant_id',

			//information fields
			'Name' => $order->cart->shipping_address->address_lastname,
			'Adress' => $order->cart->shipping_address->address_street,
			'Adress2' => $order->cart->shipping_address->address_city,
			'payment_amount' => $amount,

			//hidden parameters
			'payment_reference' => $order->order_id,
			//'reply_link_url' => $notify_url,
		);

		//switch: merchant id for testing mode:
		if($this->payment_params->testingmode)
		{
			$vars['merchant_id'] = 'TEST';

		}

		//Log check:Sending
		if($this->payment_params->debug)
		{
			$this->writeToLog("\n Data (vars1) send to westpac in Net Mode: \n\n\n");
			$this->writeToLog(print_r($vars,true));
		}

		//set to string parameters
		$post_string = '';
		foreach( $vars as $key => $value ){
			if(is_array($value)){
				foreach($value as $v){
					$post_string .= $key.'=' . urlencode( $v ) . '&';
				}
			}else{
				$post_string .= $key.'=' . urlencode( $value ) . '&';
			}
		}

		//send token request to westpac with curl
		$post_string = rtrim( $post_string, '& ');
		$url= 'https://www.payway.com.au/';
		$request = curl_init($url.'RequestToken');
		curl_setopt($request, CURLOPT_HEADER, 0);
		curl_setopt($request, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($request, CURLOPT_POSTFIELDS, $post_string);
		curl_setopt($request, CURLOPT_SSL_VERIFYPEER, FALSE);
		$post_response = curl_exec($request);

		//TESTING STRING:
		if($this->payment_params->debug)
		{
			$this->writeToLog("\n String (vars1) send to westpac in Net Mode: \n\n\n");
			$this->writeToLog(print_r($post_string,true));
		}

		//Response check:
		if(empty($post_response)){
			$this->app->enqueueMessage('The connection to the payment plateform did not succeed. It is often caused by the hosting company blocking external connections so you should contact him for further guidance. The cURL error message was: '.curl_error($request),'error');
			$do = false;
			return false;
		}

		//treatment data from payway :

		//Check the response for errors
		$errnum = curl_errno($request);
		if ($errnum != 0) {
			$errmsg = t();
			$this->app->enqueueMessage('cURL error getting token');
			return false;
		}

		curl_close ($request);

		//set Token string
		$post_response = substr(trim($post_response),6);

		//required data for authentifying response westpac platform /NET Mode
		$vars = array(

			//authentication:
			'biller_code'=>trim($this->payment_params->biller_code),
			'token'=>$post_response,
		);

		//Log check : Sending
		if($this->payment_params->debug)
		{
			$this->writeToLog("\n Data (vars2) send to westpac in Net Mode: \n\n\n");
			$this->writeToLog(print_r($vars,true));
		}

		//set to string parameters
		$post_string = '';
		foreach( $vars as $key => $value ){
			if(is_array($value)){
				foreach($value as $v){
					$post_string .= $key.'=' . urlencode( $v ) . '&';
				}
			}else{
				$post_string .= $key.'=' . urlencode( $value ) . '&';
			}
		}
		$post_string = rtrim( $post_string, '& ');

		//set payway sending url
		$this->payment_params->url = 'https://www.payway.com.au/MakePayment?';

		//TESTING STRING:
		if($this->payment_params->debug)
		{
			$this->writeToLog("\n String (vars2) send to westpac in Net Mode: \n\n\n");
			$this->writeToLog(print_r($post_string,true));
		}

		$this->vars = $vars;

		//Send the form to payway
		return $this->showPage('end');
	}


	//specific configuration (back end) default values
	function getPaymentDefaultValues(&$element)
	{
		$element->payment_name = 'westpacnet';
		$element->payment_description = 'You can pay by credit card using this payment method';
		$element->payment_images = 'MasterCard,VISA,Credit_card,American_Express';
		$element->payment_params->notification = 1;
		$element->payment_params->testingmode = 1;
		$element->payment_params->invalid_status = 'cancelled';
		$element->payment_params->verified_status = 'confirmed';
	}

	//__________________________________________________________________________
	//data back from westpac treatement

	function onPaymentNotification(&$statuses)
	{
		//Load order:
		$dbOrder = $this->getOrder((int)$_REQUEST['payment_reference']);
		$this->loadPaymentParams($dbOrder);
		if(empty($this->payment_params))
			return false;

		//Log check: recieving from payway :
		if ($this->payment_params->debug) {
			$this->writeToLog("\n POST Data recieve from Payway: \n");
			$this->writeToLog(print_r($_REQUEST,true));
		}

		//check for compare response value from payway:
		foreach ( $_POST as $paramName => $paramValue )
		{
			$params[$paramName] = $paramValue;
		}
		foreach ( $_GET as $paramName => $paramValue )
		{
			$params[$paramName] = $paramValue;
		}

		//Log check: recieving from payway :
		if ($this->payment_params->debug) {
			$this->writeToLog("\n POST Data 2 recieve from Westpac: \n");
			$this->writeToLog(print_r($_POST,true));
		}

		if(empty($this->payment_params->username) || empty($this->payment_params->password))
			return false;

		if ( $params['username'] != $this->payment_params->username	|| $params['password'] != $this->payment_params->password )
		{
			//Fraudulent payment notification.
			header( "HTTP/1.1 403 Incorrect Username and Password" );
			$this->app->enqueueMessage("Incorrect Username and password");
			die;
		}

		//Set data base order for save payment
		$order_id = (int)$params['payment_reference'];
		$dbOrder = $this->getOrder($order_id);
		$this->loadPaymentParams($dbOrder);

		//Check if transaction was approved:
		if ( $params['cd_summary'] == '0' )
		{
			$order_status = $this->payment_params->verified_status;
			$this->modifyOrder($order_id, $order_status, true, true);
		}
		else
		{
			$this->modifyOrder($order_id, $this->payment_params->invalid_status, true, true);
		}

		//Log check: recieving from payway
		if ($this->payment_params->debug) {
			$this->writeToLog(
				"Input summary code=" . $params['cd_summary']."\r\n".
				"Is this successful? " . ($params['cd_summary'] == '0' ? 'yes' : 'no'). "\r\n" .
				"Input order ID from payment reference=". $orderNumber . "\r\n" .
				"Retrieved order ID from DB=" . $d['order_id'] . "\r\n" .
				"Order status is now " . $d['order_status'] . "\r\n"
			);
		}

		if ($order_status == $this->payment_params->verified_status || $order_status == $this->payment_params->invalid_status)
		{
			// Tell PayWay that everything's fine
			echo "Success";
		}
		else
		{
			// If error results, return HTTP 500
			header("HTTP/1.1 500 Database error while updating order status");
			echo "Database error while updating order status";
		}
	}
}